{
  This file was automatically generated on 2012-09-26.

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generator git on tinkerforge.com
}

unit BrickletIndustrialDigitalIn4;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter;

const
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_VALUE = 1;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_GROUP = 2;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_GROUP = 3;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_AVAILABLE_FOR_GROUP = 4;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_DEBOUNCE_PERIOD = 5;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_DEBOUNCE_PERIOD = 6;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_INTERRUPT = 7;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_INTERRUPT = 8;
  BRICKLET_INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT = 9;

type
  TArray0To3OfChar = array [0..3] of char;

  TBrickletIndustrialDigitalIn4NotifyInterrupt = procedure(const interruptMask: word; const valueMask: word) of object;

  /// <summary>
  ///  Device for controlling up to 4 optically coupled digital inputs
  /// </summary>
  TBrickletIndustrialDigitalIn4 = class(TDevice)
  private
    interruptCallback: TBrickletIndustrialDigitalIn4NotifyInterrupt;
  protected
    procedure CallbackWrapperInterrupt(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid_: string);

    /// <summary>
    ///  Returns the input value with a bitmask. The bitmask
    ///  is 16 bit long, *true* refers to high and *false* refers to 
    ///  low.
    ///  
    ///  For example: The value 0b0000000000000011 means that pins 0-1 
    ///  are high and the other pins are low.
    ///  
    ///  If no groups are used (see <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetGroup"/>), the pins correspond to the
    ///  markings on the Digital In 4 Bricklet.
    ///  
    ///  If groups are used, the pins correspond to the element in the group.
    ///  Element 1 in the group will get pins 0-3, element 2 pins 4-7, element 3
    ///  pins 8-11 and element 4 pins 12-15.
    /// </summary>
    function GetValue: word; virtual;

    /// <summary>
    ///  Sets a group of Digital In 4 Bricklets that should work together. You can
    ///  find Bricklets that can be grouped together with <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.GetAvailableForGroup"/>.
    ///  
    ///  The group consists of 4 elements. Element 1 in the group will get pins 0-3,
    ///  element 2 pins 4-7, element 3 pins 8-11 and element 4 pins 12-15.
    ///  
    ///  Each element can either be one of the ports ('a' to 'd') or 'n' if it should
    ///  not be used.
    ///  
    ///  For example: If you have two Digital In 4 Bricklets connected to port A and
    ///  port B respectively, you could call with "['a', 'b', 'n', 'n']".
    ///  
    ///  Now the pins on the Digital In 4 on port A are assigned to 0-3 and the
    ///  pins on the Digital In 4 on port B are assigned to 4-7. It is now possible
    ///  to call <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.GetValue"/> and read out two Bricklets at the same time.
    /// </summary>
    procedure SetGroup(const group: TArray0To3OfChar); virtual;

    /// <summary>
    ///  Returns the group as set by <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetGroup"/>
    /// </summary>
    function GetGroup: TArray0To3OfChar; virtual;

    /// <summary>
    ///  Returns a bitmask of ports that are available for grouping. For example the
    ///  value 0b0101 means: Port *A* and Port *C* are connected to Bricklets that
    ///  can be grouped together.
    /// </summary>
    function GetAvailableForGroup: byte; virtual;

    /// <summary>
    ///  Sets the debounce period of the <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.Interrupt"/> callback in ms.
    ///  
    ///  For example: If you set this value to 100, you will get the interrupt
    ///  maximal every 100ms. This is necessary if something that bounces is
    ///  connected to the Digital In 4 Bricklet, such as a button.
    ///  
    ///  The default value is 100.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  Sets the pins on which an interrupt is activated with a bitmask.
    ///  Interrupts are triggered on changes of the voltage level of the pin,
    ///  i.e. changes from high to low and low to high.
    ///  
    ///  For example: An interrupt bitmask of 9 (0b0000000000001001) will 
    ///  enable the interrupt for pins 0 and 3.
    ///  
    ///  The interrupts use the grouping as set by <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetGroup"/>.
    ///  
    ///  The interrupt is delivered with the callback <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.Interrupt"/>.
    /// </summary>
    procedure SetInterrupt(const interruptMask: word); virtual;

    /// <summary>
    ///  Returns the interrupt bitmask as set by <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetInterrupt"/>.
    /// </summary>
    function GetInterrupt: word; virtual;

    /// <summary>
    ///  This callback is triggered whenever a change of the voltage level is detected
    ///  on pins where the interrupt was activated with <see cref="BrickletIndustrialDigitalIn4.TBrickletIndustrialDigitalIn4.SetInterrupt"/>.
    ///  
    ///  The values are a bitmask that specifies which interrupts occurred
    ///  and the current value bitmask.
    ///  
    ///  For example:
    ///  
    ///  * (1, 1) means that an interrupt on pin 0 occurred and
    ///    currently pin 0 is high and pins 1-3 are low.
    ///  * (9, 14) means that interrupts on pins 0 and 3
    ///    occurred and currently pin 0 is low and pins 1-3 are high.
    /// </summary>
    property OnInterrupt: TBrickletIndustrialDigitalIn4NotifyInterrupt read interruptCallback write interruptCallback;
  end;

implementation

constructor TBrickletIndustrialDigitalIn4.Create(const uid_: string);
begin
  inherited Create(uid_);
  expectedName := 'Industrial Digital In 4 Bricklet';
  bindingVersion[0] := 1;
  bindingVersion[1] := 0;
  bindingVersion[2] := 0;
  callbackWrappers[BRICKLET_INDUSTRIAL_DIGITAL_IN_4_CALLBACK_INTERRUPT] := {$ifdef FPC}@{$endif}CallbackWrapperInterrupt;
end;

function TBrickletIndustrialDigitalIn4.GetValue: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_VALUE, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_VALUE, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletIndustrialDigitalIn4.SetGroup(const group: TArray0To3OfChar);
var request: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_GROUP, 8);
  for i := 0 to Length(group) - 1 do LEConvertCharTo(group[i], 4 + (i * 1), request);
  SendRequestNoResponse(request);
end;

function TBrickletIndustrialDigitalIn4.GetGroup: TArray0To3OfChar;
var request, response: TByteArray; i: longint;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_GROUP, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_GROUP, response);
  for i := 0 to 3 do result[i] := LEConvertCharFrom(4 + (i * 1), response);
end;

function TBrickletIndustrialDigitalIn4.GetAvailableForGroup: byte;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_AVAILABLE_FOR_GROUP, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_AVAILABLE_FOR_GROUP, response);
  result := LEConvertUInt8From(4, response);
end;

procedure TBrickletIndustrialDigitalIn4.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_DEBOUNCE_PERIOD, 8);
  LEConvertUInt32To(debounce, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIndustrialDigitalIn4.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_DEBOUNCE_PERIOD, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_DEBOUNCE_PERIOD, response);
  result := LEConvertUInt32From(4, response);
end;

procedure TBrickletIndustrialDigitalIn4.SetInterrupt(const interruptMask: word);
var request: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_SET_INTERRUPT, 6);
  LEConvertUInt16To(interruptMask, 4, request);
  SendRequestNoResponse(request);
end;

function TBrickletIndustrialDigitalIn4.GetInterrupt: word;
var request, response: TByteArray;
begin
  request := CreateRequestPacket(stackID, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_INTERRUPT, 4);
  SetLength(response, 0);
  SendRequestExpectResponse(request, BRICKLET_INDUSTRIAL_DIGITAL_IN_4_FUNCTION_GET_INTERRUPT, response);
  result := LEConvertUInt16From(4, response);
end;

procedure TBrickletIndustrialDigitalIn4.CallbackWrapperInterrupt(const packet: TByteArray);
var interruptMask: word; valueMask: word;
begin
  if (Assigned(interruptCallback)) then begin
    interruptMask := LEConvertUInt16From(4, packet);
    valueMask := LEConvertUInt16From(6, packet);
    interruptCallback(interruptMask, valueMask);
  end;
end;

end.
